@prefix dct:      <http://purl.org/dc/elements/1.1/> .
@prefix flint:    <http://ontology.tno.nl/normengineering/flint/model/def/> .
@prefix act:      <http://ontology.tno.nl/normengineering/flint/actframe/model/def/> .
@prefix fact:     <http://ontology.tno.nl/normengineering/flint/factframe/model/def/> .
@prefix map:      <http://ontology.tno.nl/normengineering/flint/mapping/> .
@prefix owl:      <http://www.w3.org/2002/07/owl#> .
@prefix prov:     <http://www.w3.org/ns/prov#> .
@prefix rdf:      <http://www.w3.org/1999/02/22-rdf-syntax-ns#> .
@prefix rdfs:     <http://www.w3.org/2000/01/rdf-schema#> .
@prefix scenario: <http://ontology.tno.nl/normengineering/flint/scenario/id/> .
@prefix sh:       <http://www.w3.org/ns/shacl#> .
@prefix shp:      <http://ontology.tno.nl/normengineering/flint/model/shp/> .
@prefix xml:      <http://www.w3.org/XML/1998/namespace> .
@prefix xsd:      <http://www.w3.org/2001/XMLSchema#> .


### Algorithm mapping model

map:Mapping rdf:type owl:Class ;
  rdfs:label "Mapping";
  rdfs:comment "A mapping connects a norm with the implementation of that norm." ;
  owl:intersectionOf (
                    		[rdf:type owl:Restriction ;
                            owl:onProperty map:norm ;
                            owl:someValuesFrom rdfs:Resource]
                    		[rdf:type owl:Restriction ;
                            owl:onProperty map:implementation ;
                            owl:someValuesFrom rdfs:Resource]
                            ).

map:norm rdf:type owl:ObjectProperty;
  rdfs:label "norm" ;  
  rdfs:comment "Connects a mapping with a norm" ;
  rdfs:domain map:Mapping ;
  rdfs:range rdfs:Resource.
  
map:implementation rdf:type owl:ObjectProperty;
  rdfs:label "implementation" ;
  rdfs:comment "Connects a mapping with the implementation of a norm" ;
  rdfs:domain map:Mapping ;
  rdfs:range rdfs:Resource.

### Mapping of act frames

map:actFrame_PlayerStartsAGameOfTicTacToe
    a                    map:Mapping ;
    map:norm             act:Frame_PlayerStartsAGameOfTicTacToe ;
    map:implementation   shp:PlayerStartsAGameOfTicTacToe. 

map:actFrame_PlayerTakesTurnInAGameOfTicTacToe
    a                    map:Mapping ;
    map:norm             act:Frame_PlayerTakesTurnInAGameOfTicTacToe;
    map:implementation   shp:PlayerTakesTurnInAGameOfTicTacToe. 

map:actFrame_PlayerDeclaresATieInAGameOfTicTacToe
    a                    map:Mapping ;
    map:norm             act:Frame_PlayerDeclaresATieInAGameOfTicTacToe ;
    map:implementation   shp:PlayerDeclaresATieInAGameOfTicTacToe. 

map:actFrame_PlayerDeclaresAWinInAGameOfTicTacToe
    a                    map:Mapping ;
    map:norm             act:Frame_PlayerDeclaresAWinInAGameOfTicTacToe ;
    map:implementation   shp:PlayerDeclaresAWinInAGameOfTicTacToe. 

map:actFrame_PlayerDeclaresAFoulPlayInAGameOfTicTacToe
    a                    map:Mapping ;
    map:norm             act:Frame_PlayerDeclaresAFoulPlayInAGameOfTicTacToe ;
    map:implementation   shp:PlayerDeclaresAFoulPlayInAGameOfTicTacToe. 
	
### Mapping of SHACL validation to Flint scenario

flint:NonCompliantScenario rdfs:subClassOf flint:Scenario;
   owl:disjointWith flint:CompliantScenario;
   owl:equivalentClass 
   [rdf:type           owl:Restriction ;
   owl:onProperty     [owl:inverseOf  sh:focusNode ] ;
   owl:someValuesFrom [owl:intersectionOf (
                                              sh:ValidationResult
                                              [rdf:type           owl:Restriction ;
                                               owl:onProperty     [owl:inverseOf  sh:result ] ;
                                               owl:someValuesFrom [owl:intersectionOf (
                                                                                       sh:ValidationReport
                                                                                       [rdf:type          owl:Restriction ;
                                                                                        owl:onProperty     sh:conforms ;
                                                                                        owl:hasValue false]
                                                                                       )
                                                                  ]                    
                                              ]
                                          )
                      ]
   ]
 .
   
flint:CompliantScenario rdfs:subClassOf flint:Scenario;
    owl:disjointWith flint:NonCompliantScenario.
